<?php
/**
 * includes/config.php
 *
 * Displays and handles confirguation
 *
 * Author: BCG
 *
 */

//
//	add Admin SSL config page
//

	function as_admin_menu()
	{
		global $config_parent;
		if(function_exists("add_submenu_page") && user_can("level_10"))
			add_submenu_page($config_parent,"Admin SSL","Admin SSL",
				"manage_options","admin-ssl-config","as_conf");
	}

//
//	display/update Admin SSL configuration
//

	function as_conf()
	{
		global $use_ssl,$use_shared,$shared_url,$secure_url;
		global $additional_urls,$secure_users_only;
		global $config_page,$config_parent;
		global $https_key,$https_value;

		if(isset($_POST["submit"]))
		{
		//
		//	make sure current user can set permissions,
		//	and that the referer was a page from this site
		//

			if(!user_can("manage_options")) exit("You don't have permission to change these options!");
			check_admin_referer();

		//
		//	get the posted configuration options
		//

			$use_ssl = "on" === _post("use_ssl") ? 1 : 0;
			$use_shared = "on" === _post("use_shared") && $use_ssl ? 1 : 0;
			$shared_url = $use_shared ? _post("shared_url") : "";
			$additional_urls = _post("additional_urls");
			$secure_users_only = "on" === _post("secure_users_only") ? 1 : 0;

			$redirect = true; # if different config parent page chosen, need to redirect later
			if($config_parent === _post("config_parent") || is_wpmu()) $redirect = false;
			else $config_parent = _post("config_parent");

			$https_key = _post("https_key");
			$https_value = _post("https_value");

		//
		//	verify the selected options
		//

			//
			//	verify that $shared_url is indeed a URL
			//

				if($use_shared && !preg_match("/^https:\/\/(\w+:{0,1}\w*@)?(\S+)(:[0-9]+)?(\/|\/([\w#!:.?+=&%@!\-\/]))?/",$shared_url))
					$message = "The url you entered ('$shared_url') is invalid.";

			//
			//	verify that the shared url ends with /wp-admin/
			//

				$tmp = rtrim($shared_url,"/");

				if($use_shared && strpos($tmp,"wp-admin") !== strlen($tmp)-8)
					$message = "The url you entered ('$shared_url') does not end with '/wp-admin/'.";

				unset($tmp);

			//
			//	$config_parent may only be one of two options
			//

				if($config_parent !== "plugins.php" && $config_parent !== "options-general.php" && (is_wpmu() && $config_parent !== "wpmu-admin.php"))
					$message = "You submitted an invalid value ('$config_parent') for config parent.";

			//
			//	https key and value cannot be empty
			//

				if(trim($https_key) === "") $https_key = "HTTPS";
				if(trim($https_value) === "") $https_value = "on";

		//
		//	if there has been an error, reset all the options
		//

			if(isset($message))
			{
				$use_ssl = as_option("get","ssl_use_ssl");
				$use_shared = as_option("get","use_shared");
				$shared_url = as_option("get","shared_url");
				$additional_urls = as_option("get","additional_urls");
				$secure_users_only = as_option("get","secure_users_only");
				$config_parent = as_option("get","config_parent");
				$https_key = as_option("get","https_key");
				$https_value = as_option("get","https_value");

				as_log("as_conf()\nError saving options: $message\nResetting options to previous values");
			}
			else as_log("as_conf()\nNew option values will be saved");

		//
		//	strip index.php off the end of the URL if present and force trailing slash
		//

			if($use_shared) $shared_url = rtrim(str_replace("index.php","",$shared_url),"/")."/";

		//
		//	update options in database
		//

			as_option("update","use_ssl",$use_ssl);
			as_option("update","use_shared",$use_shared);
			as_option("update","shared_url",$shared_url);
			as_option("update","additional_urls",$additional_urls);
			as_option("update","secure_users_only",$secure_users_only);
			as_option("update","config_parent",$config_parent);
			as_option("update","https_key",$https_key);
			as_option("update","https_value",$https_value);

			if(!isset($message)) $message = "Options saved.";

		//
		//	if config parent has been changed, redirect
		//

			if($redirect)
			{
				$location = $config_parent."?page=admin-ssl-config";
				as_log("as_conf():\nRedirecting to $location");
				as_redirect($location);
			}
		}

	//
	//	require configuration settings page
	//

		require_once($config_page);
	}
?>